/*
* File:        jquery.dataTables.grouping.js
* Version:     1.1.6.
* Author:      Jovan Popovic 
* 
* Copyright 2011 Jovan Popovic, all rights reserved.
*
* This source file is free software, under either the GPL v2 license or a
* BSD style license, as supplied with this software.
* 
* This source file is distributed in the hope that it will be useful, but 
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
* or FITNESS FOR A PARTICULAR PURPOSE. 
* Parameters:
* @iGroupingColumnIndex                                 Integer             Index of the column that will be used for grouping - default 0
* @sGroupingColumnSortDirection                         Enumeration         Sort direction of the group
* @iGroupingOrderByColumnIndex                          Integer             Index of the column that will be used for ordering groups
* @sGroupingClass                                       String              Class that will be associated to the group row. Default - "group"
* @bSetGroupingClassOnTR                                Boolean             If set class will be set to the TR instead of the TD withing the grouping TR
* @bHideGroupingColumn                                  Boolean             Hide column used for grouping once results are grouped. Default - true
* @bHideGroupingOrderByColumn                           Boolean             Hide column used for ordering groups once results are grouped. Default - true
* @sGroupBy                                             Enumeration         Type of grouping that should be applied. Values "name"(default), "letter", "year"
* @sGroupLabelPrefix                                    String              Prefix that will be added to each group cell
* @bExpandableGrouping                                  Boolean             Attach expand/collapse handlers to the grouping rows
* @bExpandSingleGroup                                   Boolean             Use accordon grouping
* @iExpandGroupOffset                                   Integer             Number of pixels to set scroll position above the currently selected group. If -1 scroll will be alligned to the table
* General settings
* @sDateFormat: "dd/MM/yyyy"                            String              Date format used for grouping
* @sEmptyGroupLabel                                     String              Lable that will be placed as group if grouping cells are empty. Default "-"

* Parameters used in the second level grouping
* @iGroupingColumnIndex2                                Integer             Index of the secondary column that will be used for grouping - default 0
* @sGroupingColumnSortDirection2                        Enumeration         Sort direction of the secondary group
* @iGroupingOrderByColumnIndex2                         Integer             Index of the column that will be used for ordering secondary groups
* @sGroupingClass2                                      String              Class that will be associated to the secondary group row. Default "subgroup"
* @bHideGroupingColumn2                                 Boolean             Hide column used for secondary grouping once results are grouped. Default - true,
* @bHideGroupingOrderByColumn2                          Boolean             Hide column used for ordering secondary groups once results are grouped. Default - true,
* @sGroupBy2                                            Enumeration         Type of grouping that should be applied to secondary column. Values "name"(default), "letter", "year",
* @sGroupLabelPrefix2                                   String              Prefix that will be added to each secondary group cell
* @fnOnGrouped                                          Function            Function that is called when grouping is finished. Function has no parameters.
*/(function(a){a.fn.rowGrouping=function(b){function c(){}function d(a){var b=["January","February","March","April","May","June","Jully","August","September","October","November","December"];return b[a-1]}var e={iGroupingColumnIndex:0,sGroupingColumnSortDirection:"",iGroupingOrderByColumnIndex:-1,sGroupingClass:"group",bHideGroupingColumn:!0,bHideGroupingOrderByColumn:!0,sGroupBy:"name",sGroupLabelPrefix:"",bExpandableGrouping:!1,bExpandSingleGroup:!1,iExpandGroupOffset:100,asExpandedGroups:null,sDateFormat:"dd/MM/yyyy",sEmptyGroupLabel:"-",bSetGroupingClassOnTR:!1,iGroupingColumnIndex2:-1,sGroupingColumnSortDirection2:"",iGroupingOrderByColumnIndex2:-1,sGroupingClass2:"subgroup",bHideGroupingColumn2:!0,bHideGroupingOrderByColumn2:!0,sGroupBy2:"name",sGroupLabelPrefix2:"",bExpandableGrouping2:!1,fnOnGrouped:c};return this.each(function(c,f){function h(b){return a.inArray(b,r)!=-1}function i(a){return a.substr(p,q)}function j(a){return a}function k(a){return a.substr(0,1)}function l(a){return i(a)}function m(a){return a.substr(p,q)+" "+d(a.substr(iMonthIndex,iMonthLength))}function n(a){return a.toLowerCase().replace(/\W+/g,"-")}var g=a(f).dataTable(),o=function(b){var c=a(this).attr("rel"),d=h(c);if(t.bExpandSingleGroup){if(!d){var e=r[0];r=new Array;r.push(c);a(".group-item-"+e,g).hide();a(".group-item-"+c,g).show();var f=a(".expanded-group");f.removeClass("expanded-group");f.addClass("collapsed-group");a(this).addClass("expanded-group");a(this).removeClass("collapsed-group");if(t.iExpandGroupOffset!=-1){var i=a("#group-id-"+g.attr("id")+"-"+c).offset().top-t.iExpandGroupOffset;window.scroll(0,i)}else{var i=g.offset().top;window.scroll(0,i)}}}else if(d){var j=a.inArray(c,r);r.splice(j,1);a(this).removeClass("expanded-group");a(this).addClass("collapsed-group");a(".group-item-"+c,g).hide()}else{r.push(c);a(this).addClass("expanded-group");a(this).removeClass("collapsed-group");a(".group-item-"+c,g).show()}b.preventDefault()},p=6,q=4,r=new Array,s=!0,t=a.extend(e,b);(t.sGrupingClass!=null||t.sGrupingClass2!=null)&&alert("Since the version 1.1. sGrupingClass sGrupingClass2 are renamed to sGroupingClass and sGroupingClass2. Please correct your settings");if(t.iGroupingOrderByColumnIndex==-1){t.bCustomColumnOrdering=!1;t.iGroupingOrderByColumnIndex=t.iGroupingColumnIndex}else t.bCustomColumnOrdering=!0;t.sGroupingColumnSortDirection==""&&(t.sGroupBy=="year"?t.sGroupingColumnSortDirection="desc":t.sGroupingColumnSortDirection="asc");if(t.iGroupingOrderByColumnIndex2==-1){t.bCustomColumnOrdering2=!1;t.iGroupingOrderByColumnIndex2=t.iGroupingColumnIndex2}else t.bCustomColumnOrdering2=!0;t.sGroupingColumnSortDirection2==""&&(t.sGroupBy2=="year"?t.sGroupingColumnSortDirection2="desc":t.sGroupingColumnSortDirection2="asc");if(t.asExpandedGroups!=null)if(t.asExpandedGroups=="NONE"){t.asExpandedGroups=[];r=t.asExpandedGroups;s=!1}else if(t.asExpandedGroups!="ALL")if(t.asExpandedGroups.constructor==String){var u=t.asExpandedGroups;t.asExpandedGroups=new Array;t.asExpandedGroups.push(n(u));r=t.asExpandedGroups;s=!1}else if(t.asExpandedGroups.constructor==Array){for(var v=0;v<t.asExpandedGroups.length;v++){r.push(n(t.asExpandedGroups[v]));if(t.bExpandSingleGroup)break}s=!1}p=t.sDateFormat.toLowerCase().indexOf("yy");q=t.sDateFormat.toLowerCase().lastIndexOf("y")-t.sDateFormat.toLowerCase().indexOf("y")+1;iMonthIndex=t.sDateFormat.toLowerCase().indexOf("mm");iMonthLength=t.sDateFormat.toLowerCase().lastIndexOf("m")-t.sDateFormat.toLowerCase().indexOf("m")+1;var w=j;switch(t.sGroupBy){case"letter":w=k;break;case"year":w=l;break;case"month":w=m;break;default:w=j}var x=function(b){g.fnSettings().oFeatures.bServerSide&&(s=!0);var c=!1;t.iGroupingColumnIndex2!=-1&&(c=!0);if(b.aiDisplay.length==0)return;var d=a("tbody tr",g),e=d[0].getElementsByTagName("td").length,f=null,i=null;for(var j=0;j<d.length;j++){var k=b._iDisplayStart+j;g.fnSettings().oFeatures.bServerSide&&(k=j);var l="",m=null,p="",q=null;l=b.aoData[b.aiDisplay[k]]._aData[t.iGroupingColumnIndex];l==undefined&&(l=b.aoData[b.aiDisplay[k]]._aData[b.aoColumns[t.iGroupingColumnIndex].mDataProp]);var m=l;t.sGroupBy!="year"&&(m=w(l));a(d[j]).attr("data-group",n(m));if(c){p=b.aoData[b.aiDisplay[k]]._aData[t.iGroupingColumnIndex2];p==undefined&&(p=b.aoData[b.aiDisplay[k]]._aData[b.aoColumns[t.iGroupingColumnIndex2].mDataProp]);t.sGroupBy2!="year"&&(q=w(p));a(d[j]).attr("data-group",n(m)+"_"+n(q))}if(f==null||n(m)!=n(f)){var u=n(m);t.bExpandableGrouping&&s&&(t.bExpandSingleGroup?r.length==0&&r.push(u):r.push(u));var v=document.createElement("tr"),x=document.createElement("td");v.id="group-id-"+g.attr("id")+"-"+u;t.bSetGroupingClassOnTR?v.className=t.sGroupingClass+" "+u:x.className=t.sGroupingClass+" "+u;x.colSpan=e;x.innerHTML=t.sGroupLabelPrefix+(m==""?t.sEmptyGroupLabel:m);if(t.bExpandableGrouping){h(u)?x.className+=" expanded-group":x.className+=" collapsed-group";x.className+=" group-item-expander";a(x).attr("rel",u);a(x).click(o)}v.appendChild(x);d[j].parentNode.insertBefore(v,d[j]);f=m;i=null}if(t.bExpandableGrouping){a(d[j]).addClass("group-item-"+u);h(u)||a(d[j]).hide()}if(c)if(i==null||n(q)!=n(i)){var y=document.createElement("tr"),z=document.createElement("td");t.bSetGroupingClassOnTR?y.className=t.sGroupingClass2+" "+q.toLowerCase().replace(" ","-"):z.className=t.sGroupingClass2+" "+q.toLowerCase().replace(" ","-");z.colSpan=e;z.innerHTML=t.sGroupLabelPrefix2+(q==""?t.sEmptyGroupLabel:q);y.appendChild(z);d[j].parentNode.insertBefore(y,d[j]);i=q}}t.fnOnGrouped();s=!1};g.fnSetColumnVis(t.iGroupingColumnIndex,!t.bHideGroupingColumn);t.bCustomColumnOrdering&&g.fnSetColumnVis(t.iGroupingOrderByColumnIndex,!t.bHideGroupingOrderByColumn);t.iGroupingColumnIndex2!=-1&&g.fnSetColumnVis(t.iGroupingColumnIndex2,!t.bHideGroupingColumn2);t.bCustomColumnOrdering2&&g.fnSetColumnVis(t.iGroupingOrderByColumnIndex2,!t.bHideGroupingOrderByColumn2);g.fnSettings().aoDrawCallback.push({fn:x,sName:"fnRowGrouping"});var y=new Array;y.push([t.iGroupingOrderByColumnIndex,t.sGroupingColumnSortDirection]);t.iGroupingColumnIndex2!=-1&&y.push([t.iGroupingOrderByColumnIndex2,t.sGroupingColumnSortDirection2]);g.fnSettings().aaSortingFixed=y;switch(t.sGroupBy){case"name":break;case"letter":g.fnSettings().aoColumns[t.iGroupingOrderByColumnIndex].sSortDataType="rg-letter";a.fn.dataTableExt.afnSortData["rg-letter"]=function(b,c){var d=[];a("td:eq("+c+")",b.oApi._fnGetTrNodes(b)).each(function(){d.push(k(this.innerHTML))});return d};break;case"year":g.fnSettings().aoColumns[t.iGroupingOrderByColumnIndex].sSortDataType="rg-date";a.fn.dataTableExt.afnSortData["rg-date"]=function(b,c){var d=[];a("td:eq("+c+")",b.oApi._fnGetTrNodes(b)).each(function(){d.push(i(this.innerHTML))});return d};break;default:}t.sGroupBy!="name"&&t.sGroupBy!="letter";g.fnDraw()})}})(jQuery);